# Feature Roadmap

## Future / Maybe

  - [] UX: Improve sharpness of canvas elements
  - [] UX: Increase edge text target area
  - [] UX: Fix resolution of text
  - [] UX: Fix text padding within node
  - [] UX: Automatically scale to view port
  - [] UX: Add zoom in/out functionality map
  - [] UX: Autoscale for PNG
  - [] UX: Add automatic padding when dropping node
  - [] UX: Automatic layout options
  - [] UX: Automatically assign layout
  - [] UX: Add multiple node selection for dragging  
  - [] UX: Node line type selector (solid/dotted) 
  - [] UX: Add params option for line, overlay, background colour etc

  - [] Compatibility: Touch UI for iOS
  - [] Compatibility: Touch UI for Android

  - [] Highlighter: Specifiy target URL
  - [] Highlighter: Better icons
  - [] Highlighter: Remember selections
  - [] Highlighter: Delete selections
  - [] Highlighter: Remember selections between sessions

  - [] Scaffolder: Export graph structure to docx/rtf

## 1.0.1

  - [] Bug: Fix undo bug on Windows
  - [X] Bug: Prevent edges being added to other edges
  - [X] Bug: Fix backspace preventDefault issue

  - [X] UX: Clicking outside text area closes edit modal
  - [X] UX: Prohibit duplication connections
  - [X] UX: Tab wont add to history
  - [X] UX: Multi reason intersection moved closer to conclusion

## 1.0.0

  - [X] UX: Double click canvas to add node
  - [X] UX: Automatically highlight reason text on node creation
  - [X] UX: Double click node to edit text
  - [X] UX: Double click edge to edit text
  - [X] UX: Drag node to move position
  - [X] UX: Dragging node updates edges
  - [X] UX: Drop node on node to create edge
  - [X] UX: Automatically adjust node size from text
  - [X] UX: Focused element should be on top
  - [X] UX: Focused element visual affordances
  - [X] UX: Hover over edge text should tigger focus

  - [X] Hot Keys: Add backspace and delete key codes for Windows
  - [X] Hot Keys: Tab to different elements
  - [X] Hot Keys: Return to edit selected element
  - [X] Hot Keys: Add undo / redo hot keys
  - [X] Hot Keys: Escape to cancel overlay

  - [X] Edges: Add divergent reasons
  - [X] Edges: Conjoining reasons should only join on dropped reasons
  - [X] Edges: Add independent conjoined argument chains
  - [X] Edges: Permit multiple relations between nodes

  - [X] Compatibility: Chrome on OSX 
  - [X] Compatibility: Firefox on OSX  
  - [X] Compatibility: Safari on OSX
  - [X] Compatibility: Firefox on Windows  
  - [X] Compatibility: Chrome on Windows

  - [X] Data: Changes to canvas events should update graph object
  - [X] Data: Render map from existing x,y coordinates